SystemOrganization addCategory: #ConfigurationOfAlien!

Object subclass: #ConfigurationOfAlien
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfAlien'!

!ConfigurationOfAlien class methodsFor: 'private' stamp: 'tg 1/16/2010 01:03'!
ensureMetacello
	Smalltalk at: #MetacelloProject ifAbsent: [
		Gofer new
				url: 'http://seaside.gemstone.com/ss/metacello';
				package: 'ConfigurationOfMetacello';
				load.
		(Smalltalk at: #ConfigurationOfMetacello) loadLatestVersion ]! !

!ConfigurationOfAlien class methodsFor: 'metacello tool support' stamp: 'FernandoOlivero 1/13/2010 15:50'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfAlien class methodsFor: 'metacello tool support' stamp: 'FernandoOlivero 1/13/2010 15:50'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfAlien class methodsFor: 'loading' stamp: 'FernandoOlivero 3/19/2010 21:17'!
loadCore
	(self  project version: 'default') load: 'Core'
! !

!ConfigurationOfAlien class methodsFor: 'loading' stamp: 'tg 1/16/2010 01:22'!
loadLatestVersion
	"self loadLatestVersion"

	| project |
	project := self project.
	project updateProject.
	^project latestVersion load! !

!ConfigurationOfAlien class methodsFor: 'loading' stamp: 'FernandoOlivero 3/19/2010 21:18'!
loadLibC
	(self  project version: 'default') load: 'LibC'! !

!ConfigurationOfAlien class methodsFor: 'loading' stamp: 'FernandoOlivero 3/19/2010 21:17'!
loadMacOSX
	(self  project version: 'default') load: 'MacOSX'
! !

!ConfigurationOfAlien class methodsFor: 'loading' stamp: 'FernandoOlivero 3/19/2010 21:17'!
loadTests
	(self  project version: 'default') load: 'Tests'
! !

!ConfigurationOfAlien class methodsFor: 'loading' stamp: 'FernandoOlivero 3/19/2010 21:17'!
loadVMMaker
	(self  project version: 'default') load: 'VMMaker'
! !

!ConfigurationOfAlien class methodsFor: 'loading' stamp: 'FernandoOlivero 3/19/2010 21:18'!
loadWin32
	(self  project version: 'default') load: 'Win32'! !

!ConfigurationOfAlien class methodsFor: 'metacello tool support' stamp: 'FernandoOlivero 1/13/2010 15:50'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfAlien class methodsFor: 'accessing' stamp: 'FernandoOlivero 1/13/2010 15:50'!
project

	^self new project! !

!ConfigurationOfAlien methodsFor: 'doits' stamp: 'FernandoOlivero 1/13/2010 15:55'!
alienPostInstall
	(Smalltalk at: #ParseNode) initialize.
	(Smalltalk at: #Alien) initialize.
	(Smalltalk at: #AlienLibrary) initialize.
	(Smalltalk at: #FFICallbackThunk) initialize.
	(Smalltalk at: #Callback) initialize.
	(Smalltalk at: #UnsafeAlien) initialize! !

!ConfigurationOfAlien methodsFor: 'baselines' stamp: 'KenTreis 8/10/2010 21:46'!
baseline10: spec
	<version: '1.0-baseline'>
	spec
		for: #pharo
		do: [ 
			spec blessing: #baseline.
			spec repository: 'http://www.squeaksource.com/Alien'.
			spec package: 'Alien-Prereqs' with: [ spec preLoadDoIt: #validateSpecialObjectsArray ].
			spec
				package: 'Alien-Core'
				with: [ 
					spec
						requires: #('Alien-Prereqs');
						postLoadDoIt: #alienPostInstall ].
			spec
				package: 'Alien-Examples';
				package: 'Alien-CoreTest' with: [ spec requires: #('Alien-Core') ];
				package: 'Alien-MacOSX-Core' with: [ spec requires: #('Alien-Core') ];
				package: 'Alien-MacOSX-AppKit' with: [ spec requires: #('Alien-Core' 'Alien-MacOSX-Core') ];
				package: 'Alien-MacOSX-Examples' with: [ spec requires: #('Alien-Core') ];
				package: 'Alien-LibC' with: [ spec requires: #('Alien-Core') ];
				package: 'Alien-Win32' with: [ spec requires: #('Alien-Core') ];
				package: 'Alien-VMMaker-Support';
				package: 'Alien-VMMaker-Plugins';
				group: 'default' with: #('Core');
				group: 'Core' with: #('Alien-Core' 'Alien-Examples');
				group: 'Tests' with: #('Alien-CoreTest');
				group: 'MacOSX' with: #('Alien-MacOSX-Core' 'Alien-MacOSX-AppKit' 'Alien-MacOSX-Examples');
				group: 'LibC' with: #('Alien-LibC');
				group: 'Win32' with: #('Alien-Win32');
				group: 'VMMaker' with: #('Alien-VMMaker-Support' 'Alien-VMMaker-Plugins') ]! !

!ConfigurationOfAlien methodsFor: 'baselines' stamp: 'LucFabresse 1/30/2011 12:07'!
baseline12: spec
	<version: '1.2-baseline'>
	spec
		for: #pharo
		do: [ 
			spec blessing: #baseline.
			spec repository: 'http://www.squeaksource.com/Alien'.
			spec package: 'Alien-Prereqs' with: [ spec preLoadDoIt: #validateSpecialObjectsArrayPharo12 ].
			spec
				package: 'Alien-Core'
				with: [ 
					spec
						requires: #('Alien-Prereqs');
						postLoadDoIt: #alienPostInstall ].
			spec
				package: 'Alien-Examples';
				package: 'Alien-CoreTest' with: [ spec requires: #('Alien-Core' 'Alien-Examples') ];
				package: 'Alien-MacOSX-Core' with: [ spec requires: #('Alien-Core') ];
				package: 'Alien-MacOSX-AppKit' with: [ spec requires: #('Alien-Core' 'Alien-MacOSX-Core') ];
				package: 'Alien-MacOSX-Examples' with: [ spec requires: #('Alien-Core') ];
				package: 'Alien-LibC' with: [ spec requires: #('Alien-Core') ];
				package: 'Alien-Win32' with: [ spec requires: #('Alien-Core') ];
				package: 'Alien-VMMaker-Support';
				package: 'Alien-VMMaker-Plugins';
				group: 'default' with: #('Core');
				group: 'Core' with: #('Alien-Core' 'Alien-Examples');
				group: 'Tests' with: #('Alien-CoreTest');
				group: 'MacOSX' with: #('Alien-MacOSX-Core' 'Alien-MacOSX-AppKit' 'Alien-MacOSX-Examples');
				group: 'LibC' with: #('Alien-LibC');
				group: 'Win32' with: #('Alien-Win32');
				group: 'VMMaker' with: #('Alien-VMMaker-Support' 'Alien-VMMaker-Plugins') ]! !

!ConfigurationOfAlien methodsFor: 'versions' stamp: 'FernandoOlivero 3/19/2010 21:17'!
default: spec 
	<version: 'default' imports: #('1.0-baseline')>
	spec for: #common do: [
		spec blessing: #development.
		spec repository: 'http://www.squeaksource.com/Alien'.
		spec author:'JohnMcintosh'].! !

!ConfigurationOfAlien methodsFor: 'versions' stamp: 'LucFabresse 1/30/2011 11:41'!
pharo11: spec
	<version: 'Pharo 1.1' imports: #('1.0-baseline')>
	
	^self version10: spec! !

!ConfigurationOfAlien methodsFor: 'versions' stamp: 'LucFabresse 1/30/2011 11:58'!
pharo12: spec
	<version: 'Pharo 1.2' imports: #('1.2-baseline')>

	^self version12:  spec! !

!ConfigurationOfAlien methodsFor: 'accessing' stamp: 'FernandoOlivero 1/13/2010 15:50'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear.
		project ]! !

!ConfigurationOfAlien methodsFor: 'doits' stamp: 'FernandoOlivero 1/13/2010 16:03'!
validateSpecialObjectsArray
	( ( Smalltalk classNamed: #Alien ) isNil and:[ 
		(Smalltalk specialObjectsArray size = 50) not ] )
		ifTrue:[ ^ self error: 'This version of ALIEN assumes a size of 50 in the array of special objects, if loaded would cause the image to crash!!. Please contact the Alien package developers'].
	! !

!ConfigurationOfAlien methodsFor: 'doits' stamp: 'LucFabresse 1/30/2011 10:40'!
validateSpecialObjectsArrayPharo12
	( ( Smalltalk classNamed: #Alien ) isNil and:[ 
		(Smalltalk specialObjectsArray size = 56) not ] )
		ifTrue:[ ^ self error: 'This version of ALIEN assumes a size of 56 in the array of special objects, if loaded would cause the image to crash!!. Please contact the Alien package developers'].
	! !

!ConfigurationOfAlien methodsFor: 'versions' stamp: 'LucFabresse 1/30/2011 11:57'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>

	spec for: #pharo do: [
		spec blessing: #release.
		spec 
			package: 'Alien-Prereqs' with: 'Alien-Prereqs-mha.3';
			package: 'Alien-Core' with: 'Alien-Core-John_M_McIntosh.63';
			package: 'Alien-CoreTest' with: 'Alien-CoreTest-F_Olivero.22';
			package: 'Alien-LibC' with: 'Alien-LibC-mha.9' ;
			package: 'Alien-MacOS-Core' with: 'Alien-MacOSX-Core-John_M_McIntosh.2'			
	].! !

!ConfigurationOfAlien methodsFor: 'versions' stamp: 'LucFabresse 1/30/2011 12:36'!
version12: spec
	<version: '1.2' imports: #('1.2-baseline')>

	spec
		for: #pharo
		do: [ 
			spec blessing: #development.
			spec
				package: 'Alien-Prereqs' with: 'Alien-Prereqs-KenTreis.5';
				package: 'Alien-Core' with: 'Alien-Core-LucFabresse.67';
				package: 'Alien-CoreTest' with: 'Alien-CoreTest-F_Olivero.22'
		]! !
